using namespace std;
#include<fstream>
#include<iostream>
#include <cstdlib>
#include <stdio.h>
#include<string.h>
#include<ctype.h>
#include<cmath>  //note: math functions are all double as standard
#include "extern_proto.h"

int ending_part()
{
  extern void vsetval(int*,int,int);
  extern void Sort(int,float*,int*,bool);
  extern void Sort(int,int*,int*,bool);
  int ievt,ivar,itr,inode,itree,icut,isum,i;
  if (!training_or_data)  //training run
    {
      if (ada_or_epsilon)
	//here for ada boost
	{cout<<"ada boost, ada constant = "<<alpha_const<<"\n";}
      else
	//here for epsilon boost
	{cout<<"epsilon boost, epsilon = "<<epsilon<<"\n";}
      cout<<"randomize_training_sample = "<<randomize_training_sample<<"\n";
      cout<<"random seed = "<<random_seed<<" num variables = "<<nvar<<"\n";
      cout<<"fraction training sample for each tree = "<<fraction_train_for_tree
	  <<"\n";
      cout<<"fraction of variables for each node = "<<fraction_var_for_node<<"\n";
      cout<<"number of training signal events = "<<num_train_sig<<
	", number of training background events = "<<num_train_bkrd<<"\n";
      cout<<"number of test signal events = "<<(num_sig-num_train_sig)
	  <<",  number of test background events = "<<(num_bkrd-num_train_bkrd)
	  <<"\n";
      cout<<"max number trees = "<<max_num_trees<<", number of nodes = "
	  <<max_nodes<<", number leaves = "<<max_leaves<<"\n";
      cout<<"purity cut = "<<purity_cut<<", min allowed weight = "
	  <<min_allowed_weight<< "trim weight = "<<trim_wgt<<"\n"; 
      cout<<" ratio for 10--90% signal kept = ";
      cout <<ratio[1]<<" "<<ratio[2]<<" "<<ratio[3]<<" "<<ratio[4]
	   <<" "<<ratio[5]<<"\n "<<ratio[6]<<" "<<ratio[7]<<" "
	   <<ratio[8]<<" "<<ratio[9]<<"\n";
      cout<<"The minimum ratio "<<min_ratio<<" was achieved for tree "<<min_tree<<"\n";
      //  Write out the best tree information for a training run
      if (!num_file_tree)
	{
	  // There is no file for writing tree.  Set iresult 1 and quit
	  cout<<"no file for writing tree out on training run \n";
	  return 1;
	}
      //There is a file for writing tree.  Allow only 1 file and read it.
      std::ofstream tree_out (file_tree[0]);
      //	from_sig>>num_sig>>num_bkrd;
      tree_out<<min_ratio<<" "<<min_tree<<" "<<num_sig<<" "
	      <<num_bkrd<<" "<<num_train_sig<<" "<<num_train_bkrd<<" "
	      <<max_nodes<<" "<<sum_T_m_save<<" "<<epsilon<<" "
	      <<alpha_const<<" "<<purity_cut<<" "<<ada_or_epsilon<<"\n ";
      for(itr=0;itr<=min_tree;itr++) tree_out<<alpha_m_save[itr]<<" ";
      tree_out<<"\n";
      for (itr=0;itr<=min_tree;itr++)
	{
	  for(inode=0;inode<max_nodes;inode++)
	    {
	      tree_out<<purity_right_save[inode][itr]<<" ";
	      tree_out<<purity_left_save[inode][itr]<<" ";
	      tree_out<<next_right_node_save[inode][itr]<<" ";
	      tree_out<<next_left_node_save[inode][itr]<<" ";
	      tree_out<<node_var_save[inode][itr]<<" ";
	      tree_out<<node_val_save[inode][itr]<<" ";
	    }
	}
      //end of parameters for file_results_out
      vsetval(times_var_used,nvar+1,0);
      for (itr=0;itr<min_tree;itr++)
	{
	  for(inode=0;inode<max_nodes;inode++)
	    {
	      if (node_var_save[inode][itr] >= 0) 
		times_var_used[node_var_save[inode][itr]]++;
	      else
		times_var_used[nvar]++;
	    }
	}
      Sort(nvar,times_var_used,sorted_times_index,1);
      for(itr=0;itr<nvar;itr++)
	{
	  cout<<sorted_times_index[itr]<<" ";
	  cout<<times_var_used[sorted_times_index[itr]]<<"     ";
	  if ((itr/4)*4==itr) cout<<"\n";
	}
      cout<<"Number of times with no variable = "<<times_var_used[nvar]<<"\n";
      //      cout<< "sum_T_m_min,sum_T_m_max"<<sum_T_m_min<<" "
      //<<sum_T_m_max<<"\n";
      //cout<<"test,num_sig-num_train_sig"<<test<<" "<<num_sig-num_train_sig
      //<<"\n";
      //cout<<"itree_last"<<itree_last<<"\n";
      //
      // Now write out the file_results_out which has data for a further
      // program to histogram
      if (!num_file_results_out)
	{
	  // There is no file for writing results.  Set return 1 and quit
	  cout<<"no file_results_out specified  for training run \n";
	  return 1;
	}
      //There is a file for writing results out.  
      //Allow only 1 file and read it.
      std::ofstream results_out (file_results_out[0]);
      
      //
      results_out<<num_train_sig<<" "<<num_train_bkrd<<" "<<max_num_trees<<"\n";
      results_out<<num_sig-num_train_sig<<" "<<num_bkrd-num_train_bkrd<<"\n";
      for (icut=1;icut<10;icut++)
	{
	  results_out<<frac_kept_sig[icut]<<" "<<frac_kept_bkrd[icut]<<" "
		     <<ratio[icut]<<" "<<num_kept_sig<<" "
		     <<num_kept_bkrd<<"\n";
	   }
    }
  else  //data run
    {
      if (!num_file_data_out)
	{
	  // There is no file for writing date out.  Set return 1 and quit
	  cout<<"no file for writing data out on data run \n";
	  return 1;
	}
      //There is a file for writing data.  Allow only 1 file and read it.
      std::ofstream data_out (file_data_out[0]);
      
      //
      data_out<<num_data<<" ";
      data_out<<num_file_tree_old+num_file_tree<<" ";
      data_out<<nvar_in<<"\n";
      cout<<"num_data = "<<num_data<<"\n";
      for (ievt=0;ievt<num_data;ievt++)
	{
	  if (nprefix>0)
	    {
	      for(i=0;i<nprefix;i++) data_out<<prefix[ievt][i]<<" ";
	      data_out<<"\n";
	    }	  
	  for(isum=0;isum<num_file_tree_old+num_file_tree;isum++)
	    {
	      data_out<<sum_T_m_dat[isum][ievt]<<" ";
	    }
	  data_out<<"\n";
	  for (ivar=0;ivar<nvar_in;ivar++)
	    {data_out<<event_dat[ievt][ivar]<<" ";
	    //	    if(((ivar+1)/10)*10==ivar) data_out<<"\n";
	    }
	  data_out<<"\n";
	}
      //end of writing data_out
    }
  return 0;
}

